<?php

	class LDAPConfig{
		
		private $ldap_server_url;
		
		private $ldap_bind_account_dn;
		
		private $ldap_bind_account_password;
		
		private $search_base;
		
		private $search_filter;
		
		private $user_attributes;
		
		private $ldapconn;
		
		function __construct(){
			
			$this->ldap_server_url = "";																	//Set LDAP Server URL
			$this->ldap_bind_account_dn = "";																//Set LDAP Bind Account DN
			$this->ldap_bind_account_password = "";															//Set LDAP Bind Account Password
			$this->search_base = "";																		//Set LDAP Search Base
			$this->search_filter = "(|(userprincipalname=?)(samaccountname=?))";							//Set LDAP Search Filter
			$this->user_attributes = array("givenname", "sn", "mail", "department", "userprincipalname");	//Set LDAP Attributes(in array form) to be fetched
			
		}
		
		function getConnection(){
			$this->ldapconn = @ldap_connect($this->ldap_server_url);
				
			ldap_set_option($ldapconn, LDAP_OPT_PROTOCOL_VERSION, 3);
			ldap_set_option($ldapconn, LDAP_OPT_REFERRALS, 0);

			if ($this->ldapconn) {

				// binding to ldap server
				$ldapbind = @ldap_bind($this->ldapconn, $this->ldap_bind_account_dn, $this->ldap_bind_account_password);
				// verify binding
				if ($ldapbind) {
					//Bind successful. Return Connection
					//return $ldapconn;
				} else {
					echo ldap_errno($this->ldapconn) . ": " . ldap_error($this->ldapconn);
				}

			}
		}
		
		function getUserAttributes($username){
			$this->search_filter = str_replace('?', $username, $this->search_filter);
			$user_search_result = ldap_search($this->ldapconn, $this->search_base, $this->search_filter, $this->user_attributes);
			$attributes = array();
			if($user_search_result){
				$entry = ldap_get_entries($this->ldapconn, $user_search_result);
				foreach($this->user_attributes as $attr){
					$attributes[$attr] = $entry[0][$attr][0];
				}
				return $attributes;
			}
		}
		
	}

?>