<?php
	require_once 'samlresponse.php';
	require_once 'ldapconfig.php';
	require_once 'includes/AuthnRequest.php';
	
	$acs_url = '';										//ACS URL
	$issuer = '';										//ISSUER
	$audience = '';										//AUDIENCE

	$requestId = null;
	$relayState = null;

	if(array_key_exists('SAMLRequest', $_REQUEST) && !empty($_REQUEST['SAMLRequest'])){
		$samlRequest = base64_decode($_REQUEST['SAMLRequest']);
		if(array_key_exists('RelayState', $_REQUEST)) {
			$relayState = $_REQUEST['RelayState'];
		}
		if(array_key_exists('SAMLRequest', $_GET) && !empty($_GET['SAMLRequest'])) {
			$samlRequest = gzinflate($samlRequest);
		}
		
		$document = new DOMDocument();
		$document->loadXML($samlRequest);
		$samlRequestXML = $document->firstChild;
		$authnRequest = new MiniOrangeAuthnRequest($samlRequestXML);

		$requestId = $authnRequest->getRequestID();
	}
	
	$username = $_SERVER['REMOTE_USER'];	//Domain User. 
	//var_dump($username);exit;

	//Remove domain name from the username
	//$username = substr($username, strpos($username, "\\")+1);
	if(strpos($username, '@') !== false) {
		$username = substr($username, 0, strpos($username, '@'));
	} else {
		$username = array_pop(explode("\\", $username));
	}
	
	//Get LDAP attributes
	$attributes_list = array();
	$ldap_config = new LDAPConfig();
	$ldap_config->getConnection();
	$attributes_list = $ldap_config->getUserAttributes($username);	
	//var_dump($attributes_list);exit;
	
	$saml_response_obj = new SamlResponse($username, $acs_url, $issuer, $audience, $attributes_list, $requestId);
	$saml_response = $saml_response_obj->createSamlResponse();
	?>
	<form id="responseform" action="<?php echo $acs_url; ?>" method="post">
		<input type="hidden" name="SAMLResponse" value="<?php echo $saml_response; ?>" />
		<?php
			if (!is_null($relayState)) { ?>
				<input type="hidden" name="RelayState" value="<?php echo $relayState; ?>" />
		<?php	} ?>
	</form>
	<script>
		document.getElementById('responseform').submit();
	</script>